package com.sun.java.swing.plaf.windows;

import java.awt.Insets;
import java.awt.Point;
import java.awt.Dimension;
import java.awt.Color;
import sun.awt.windows.ThemeReader;
import java.util.EnumMap;
import javax.swing.JComponent;
import java.awt.Component;

class TMSchema
{
    TMSchema() {
    }
    
    public enum Control
    {
        BUTTON, 
        COMBOBOX, 
        EDIT, 
        HEADER, 
        LISTBOX, 
        LISTVIEW, 
        MENU, 
        PROGRESS, 
        REBAR, 
        SCROLLBAR, 
        SPIN, 
        TAB, 
        TOOLBAR, 
        TRACKBAR, 
        TREEVIEW, 
        WINDOW;
    }
    
    public enum Part
    {
        MENU(TMSchema.Control.MENU, 0), 
        MP_BARBACKGROUND(TMSchema.Control.MENU, 7), 
        MP_BARITEM(TMSchema.Control.MENU, 8), 
        MP_POPUPBACKGROUND(TMSchema.Control.MENU, 9), 
        MP_POPUPBORDERS(TMSchema.Control.MENU, 10), 
        MP_POPUPCHECK(TMSchema.Control.MENU, 11), 
        MP_POPUPCHECKBACKGROUND(TMSchema.Control.MENU, 12), 
        MP_POPUPGUTTER(TMSchema.Control.MENU, 13), 
        MP_POPUPITEM(TMSchema.Control.MENU, 14), 
        MP_POPUPSEPARATOR(TMSchema.Control.MENU, 15), 
        MP_POPUPSUBMENU(TMSchema.Control.MENU, 16), 
        BP_PUSHBUTTON(TMSchema.Control.BUTTON, 1), 
        BP_RADIOBUTTON(TMSchema.Control.BUTTON, 2), 
        BP_CHECKBOX(TMSchema.Control.BUTTON, 3), 
        BP_GROUPBOX(TMSchema.Control.BUTTON, 4), 
        CP_COMBOBOX(TMSchema.Control.COMBOBOX, 0), 
        CP_DROPDOWNBUTTON(TMSchema.Control.COMBOBOX, 1), 
        CP_BACKGROUND(TMSchema.Control.COMBOBOX, 2), 
        CP_TRANSPARENTBACKGROUND(TMSchema.Control.COMBOBOX, 3), 
        CP_BORDER(TMSchema.Control.COMBOBOX, 4), 
        CP_READONLY(TMSchema.Control.COMBOBOX, 5), 
        CP_DROPDOWNBUTTONRIGHT(TMSchema.Control.COMBOBOX, 6), 
        CP_DROPDOWNBUTTONLEFT(TMSchema.Control.COMBOBOX, 7), 
        CP_CUEBANNER(TMSchema.Control.COMBOBOX, 8), 
        EP_EDIT(TMSchema.Control.EDIT, 0), 
        EP_EDITTEXT(TMSchema.Control.EDIT, 1), 
        HP_HEADERITEM(TMSchema.Control.HEADER, 1), 
        HP_HEADERSORTARROW(TMSchema.Control.HEADER, 4), 
        LBP_LISTBOX(TMSchema.Control.LISTBOX, 0), 
        LVP_LISTVIEW(TMSchema.Control.LISTVIEW, 0), 
        PP_PROGRESS(TMSchema.Control.PROGRESS, 0), 
        PP_BAR(TMSchema.Control.PROGRESS, 1), 
        PP_BARVERT(TMSchema.Control.PROGRESS, 2), 
        PP_CHUNK(TMSchema.Control.PROGRESS, 3), 
        PP_CHUNKVERT(TMSchema.Control.PROGRESS, 4), 
        RP_GRIPPER(TMSchema.Control.REBAR, 1), 
        RP_GRIPPERVERT(TMSchema.Control.REBAR, 2), 
        SBP_SCROLLBAR(TMSchema.Control.SCROLLBAR, 0), 
        SBP_ARROWBTN(TMSchema.Control.SCROLLBAR, 1), 
        SBP_THUMBBTNHORZ(TMSchema.Control.SCROLLBAR, 2), 
        SBP_THUMBBTNVERT(TMSchema.Control.SCROLLBAR, 3), 
        SBP_LOWERTRACKHORZ(TMSchema.Control.SCROLLBAR, 4), 
        SBP_UPPERTRACKHORZ(TMSchema.Control.SCROLLBAR, 5), 
        SBP_LOWERTRACKVERT(TMSchema.Control.SCROLLBAR, 6), 
        SBP_UPPERTRACKVERT(TMSchema.Control.SCROLLBAR, 7), 
        SBP_GRIPPERHORZ(TMSchema.Control.SCROLLBAR, 8), 
        SBP_GRIPPERVERT(TMSchema.Control.SCROLLBAR, 9), 
        SBP_SIZEBOX(TMSchema.Control.SCROLLBAR, 10), 
        SPNP_UP(TMSchema.Control.SPIN, 1), 
        SPNP_DOWN(TMSchema.Control.SPIN, 2), 
        TABP_TABITEM(TMSchema.Control.TAB, 1), 
        TABP_TABITEMLEFTEDGE(TMSchema.Control.TAB, 2), 
        TABP_TABITEMRIGHTEDGE(TMSchema.Control.TAB, 3), 
        TABP_PANE(TMSchema.Control.TAB, 9), 
        TP_TOOLBAR(TMSchema.Control.TOOLBAR, 0), 
        TP_BUTTON(TMSchema.Control.TOOLBAR, 1), 
        TP_SEPARATOR(TMSchema.Control.TOOLBAR, 5), 
        TP_SEPARATORVERT(TMSchema.Control.TOOLBAR, 6), 
        TKP_TRACK(TMSchema.Control.TRACKBAR, 1), 
        TKP_TRACKVERT(TMSchema.Control.TRACKBAR, 2), 
        TKP_THUMB(TMSchema.Control.TRACKBAR, 3), 
        TKP_THUMBBOTTOM(TMSchema.Control.TRACKBAR, 4), 
        TKP_THUMBTOP(TMSchema.Control.TRACKBAR, 5), 
        TKP_THUMBVERT(TMSchema.Control.TRACKBAR, 6), 
        TKP_THUMBLEFT(TMSchema.Control.TRACKBAR, 7), 
        TKP_THUMBRIGHT(TMSchema.Control.TRACKBAR, 8), 
        TKP_TICS(TMSchema.Control.TRACKBAR, 9), 
        TKP_TICSVERT(TMSchema.Control.TRACKBAR, 10), 
        TVP_TREEVIEW(TMSchema.Control.TREEVIEW, 0), 
        TVP_GLYPH(TMSchema.Control.TREEVIEW, 2), 
        WP_WINDOW(TMSchema.Control.WINDOW, 0), 
        WP_CAPTION(TMSchema.Control.WINDOW, 1), 
        WP_MINCAPTION(TMSchema.Control.WINDOW, 3), 
        WP_MAXCAPTION(TMSchema.Control.WINDOW, 5), 
        WP_FRAMELEFT(TMSchema.Control.WINDOW, 7), 
        WP_FRAMERIGHT(TMSchema.Control.WINDOW, 8), 
        WP_FRAMEBOTTOM(TMSchema.Control.WINDOW, 9), 
        WP_SYSBUTTON(TMSchema.Control.WINDOW, 13), 
        WP_MDISYSBUTTON(TMSchema.Control.WINDOW, 14), 
        WP_MINBUTTON(TMSchema.Control.WINDOW, 15), 
        WP_MDIMINBUTTON(TMSchema.Control.WINDOW, 16), 
        WP_MAXBUTTON(TMSchema.Control.WINDOW, 17), 
        WP_CLOSEBUTTON(TMSchema.Control.WINDOW, 18), 
        WP_MDICLOSEBUTTON(TMSchema.Control.WINDOW, 20), 
        WP_RESTOREBUTTON(TMSchema.Control.WINDOW, 21), 
        WP_MDIRESTOREBUTTON(TMSchema.Control.WINDOW, 22);
        
        private final TMSchema.Control control;
        private final int value;
        
        private Part(TMSchema.Control control, int value) {
            this.control = control;
            this.value = value;
        }
        
        public int getValue() {
            return this.value;
        }
        
        public String getControlName(Component component) {
            String string = "";
            if ((component instanceof JComponent)) {
                String str = (String)((JComponent)component).getClientProperty("XPStyle.subAppName");
                if (str != null) {
                    string = str + "::";
                }
            }
            return string + this.control.toString();
        }
        
        @Override
        public String toString() {
            return this.control.toString() + "." + this.name();
        }
    }
    
    public enum State
    {
        ACTIVE, 
        ASSIST, 
        BITMAP, 
        CHECKED, 
        CHECKEDDISABLED, 
        CHECKEDHOT, 
        CHECKEDNORMAL, 
        CHECKEDPRESSED, 
        CHECKMARKNORMAL, 
        CHECKMARKDISABLED, 
        BULLETNORMAL, 
        BULLETDISABLED, 
        CLOSED, 
        DEFAULTED, 
        DISABLED, 
        DISABLEDHOT, 
        DISABLEDPUSHED, 
        DOWNDISABLED, 
        DOWNHOT, 
        DOWNNORMAL, 
        DOWNPRESSED, 
        FOCUSED, 
        HOT, 
        HOTCHECKED, 
        ICONHOT, 
        ICONNORMAL, 
        ICONPRESSED, 
        ICONSORTEDHOT, 
        ICONSORTEDNORMAL, 
        ICONSORTEDPRESSED, 
        INACTIVE, 
        INACTIVENORMAL, 
        INACTIVEHOT, 
        INACTIVEPUSHED, 
        INACTIVEDISABLED, 
        LEFTDISABLED, 
        LEFTHOT, 
        LEFTNORMAL, 
        LEFTPRESSED, 
        MIXEDDISABLED, 
        MIXEDHOT, 
        MIXEDNORMAL, 
        MIXEDPRESSED, 
        NORMAL, 
        PRESSED, 
        OPENED, 
        PUSHED, 
        READONLY, 
        RIGHTDISABLED, 
        RIGHTHOT, 
        RIGHTNORMAL, 
        RIGHTPRESSED, 
        SELECTED, 
        UNCHECKEDDISABLED, 
        UNCHECKEDHOT, 
        UNCHECKEDNORMAL, 
        UNCHECKEDPRESSED, 
        UPDISABLED, 
        UPHOT, 
        UPNORMAL, 
        UPPRESSED, 
        HOVER, 
        UPHOVER, 
        DOWNHOVER, 
        LEFTHOVER, 
        RIGHTHOVER, 
        SORTEDDOWN, 
        SORTEDHOT, 
        SORTEDNORMAL, 
        SORTEDPRESSED, 
        SORTEDUP;
        
        private static EnumMap<TMSchema.Part, TMSchema.State[]> stateMap;
        
        private static synchronized void initStates() {
            (TMSchema.State.stateMap = new EnumMap(TMSchema.Part.class)).put(TMSchema.Part.EP_EDITTEXT, new TMSchema.State[] { TMSchema.State.NORMAL, TMSchema.State.HOT, TMSchema.State.SELECTED, TMSchema.State.DISABLED, TMSchema.State.FOCUSED, TMSchema.State.READONLY, TMSchema.State.ASSIST });
            TMSchema.State.stateMap.put(TMSchema.Part.BP_PUSHBUTTON, new TMSchema.State[] { TMSchema.State.NORMAL, TMSchema.State.HOT, TMSchema.State.PRESSED, TMSchema.State.DISABLED, TMSchema.State.DEFAULTED });
            TMSchema.State.stateMap.put(TMSchema.Part.BP_RADIOBUTTON, new TMSchema.State[] { TMSchema.State.UNCHECKEDNORMAL, TMSchema.State.UNCHECKEDHOT, TMSchema.State.UNCHECKEDPRESSED, TMSchema.State.UNCHECKEDDISABLED, TMSchema.State.CHECKEDNORMAL, TMSchema.State.CHECKEDHOT, TMSchema.State.CHECKEDPRESSED, TMSchema.State.CHECKEDDISABLED });
            TMSchema.State.stateMap.put(TMSchema.Part.BP_CHECKBOX, new TMSchema.State[] { TMSchema.State.UNCHECKEDNORMAL, TMSchema.State.UNCHECKEDHOT, TMSchema.State.UNCHECKEDPRESSED, TMSchema.State.UNCHECKEDDISABLED, TMSchema.State.CHECKEDNORMAL, TMSchema.State.CHECKEDHOT, TMSchema.State.CHECKEDPRESSED, TMSchema.State.CHECKEDDISABLED, TMSchema.State.MIXEDNORMAL, TMSchema.State.MIXEDHOT, TMSchema.State.MIXEDPRESSED, TMSchema.State.MIXEDDISABLED });
            TMSchema.State[] value = { TMSchema.State.NORMAL, TMSchema.State.HOT, TMSchema.State.PRESSED, TMSchema.State.DISABLED };
            TMSchema.State.stateMap.put(TMSchema.Part.CP_COMBOBOX, value);
            TMSchema.State.stateMap.put(TMSchema.Part.CP_DROPDOWNBUTTON, value);
            TMSchema.State.stateMap.put(TMSchema.Part.CP_BACKGROUND, value);
            TMSchema.State.stateMap.put(TMSchema.Part.CP_TRANSPARENTBACKGROUND, value);
            TMSchema.State.stateMap.put(TMSchema.Part.CP_BORDER, value);
            TMSchema.State.stateMap.put(TMSchema.Part.CP_READONLY, value);
            TMSchema.State.stateMap.put(TMSchema.Part.CP_DROPDOWNBUTTONRIGHT, value);
            TMSchema.State.stateMap.put(TMSchema.Part.CP_DROPDOWNBUTTONLEFT, value);
            TMSchema.State.stateMap.put(TMSchema.Part.CP_CUEBANNER, value);
            TMSchema.State.stateMap.put(TMSchema.Part.HP_HEADERITEM, new TMSchema.State[] { TMSchema.State.NORMAL, TMSchema.State.HOT, TMSchema.State.PRESSED, TMSchema.State.SORTEDNORMAL, TMSchema.State.SORTEDHOT, TMSchema.State.SORTEDPRESSED, TMSchema.State.ICONNORMAL, TMSchema.State.ICONHOT, TMSchema.State.ICONPRESSED, TMSchema.State.ICONSORTEDNORMAL, TMSchema.State.ICONSORTEDHOT, TMSchema.State.ICONSORTEDPRESSED });
            TMSchema.State.stateMap.put(TMSchema.Part.HP_HEADERSORTARROW, new TMSchema.State[] { TMSchema.State.SORTEDDOWN, TMSchema.State.SORTEDUP });
            TMSchema.State[] value2 = { TMSchema.State.NORMAL, TMSchema.State.HOT, TMSchema.State.PRESSED, TMSchema.State.DISABLED, TMSchema.State.HOVER };
            TMSchema.State.stateMap.put(TMSchema.Part.SBP_SCROLLBAR, value2);
            TMSchema.State.stateMap.put(TMSchema.Part.SBP_THUMBBTNVERT, value2);
            TMSchema.State.stateMap.put(TMSchema.Part.SBP_THUMBBTNHORZ, value2);
            TMSchema.State.stateMap.put(TMSchema.Part.SBP_GRIPPERVERT, value2);
            TMSchema.State.stateMap.put(TMSchema.Part.SBP_GRIPPERHORZ, value2);
            TMSchema.State.stateMap.put(TMSchema.Part.SBP_ARROWBTN, new TMSchema.State[] { TMSchema.State.UPNORMAL, TMSchema.State.UPHOT, TMSchema.State.UPPRESSED, TMSchema.State.UPDISABLED, TMSchema.State.DOWNNORMAL, TMSchema.State.DOWNHOT, TMSchema.State.DOWNPRESSED, TMSchema.State.DOWNDISABLED, TMSchema.State.LEFTNORMAL, TMSchema.State.LEFTHOT, TMSchema.State.LEFTPRESSED, TMSchema.State.LEFTDISABLED, TMSchema.State.RIGHTNORMAL, TMSchema.State.RIGHTHOT, TMSchema.State.RIGHTPRESSED, TMSchema.State.RIGHTDISABLED, TMSchema.State.UPHOVER, TMSchema.State.DOWNHOVER, TMSchema.State.LEFTHOVER, TMSchema.State.RIGHTHOVER });
            TMSchema.State[] array = { TMSchema.State.NORMAL, TMSchema.State.HOT, TMSchema.State.PRESSED, TMSchema.State.DISABLED };
            TMSchema.State.stateMap.put(TMSchema.Part.SPNP_UP, array);
            TMSchema.State.stateMap.put(TMSchema.Part.SPNP_DOWN, array);
            TMSchema.State.stateMap.put(TMSchema.Part.TVP_GLYPH, new TMSchema.State[] { TMSchema.State.CLOSED, TMSchema.State.OPENED });
            TMSchema.State[] array2 = { TMSchema.State.NORMAL, TMSchema.State.HOT, TMSchema.State.PUSHED, TMSchema.State.DISABLED, TMSchema.State.INACTIVENORMAL, TMSchema.State.INACTIVEHOT, TMSchema.State.INACTIVEPUSHED, TMSchema.State.INACTIVEDISABLED };
            if (ThemeReader.getInt(TMSchema.Control.WINDOW.toString(), TMSchema.Part.WP_CLOSEBUTTON.getValue(), 1, TMSchema.Prop.IMAGECOUNT.getValue()) == 10) {
                array2 = new TMSchema.State[] { TMSchema.State.NORMAL, TMSchema.State.HOT, TMSchema.State.PUSHED, TMSchema.State.DISABLED, null, TMSchema.State.INACTIVENORMAL, TMSchema.State.INACTIVEHOT, TMSchema.State.INACTIVEPUSHED, TMSchema.State.INACTIVEDISABLED, null };
            }
            TMSchema.State.stateMap.put(TMSchema.Part.WP_MINBUTTON, array2);
            TMSchema.State.stateMap.put(TMSchema.Part.WP_MAXBUTTON, array2);
            TMSchema.State.stateMap.put(TMSchema.Part.WP_RESTOREBUTTON, array2);
            TMSchema.State.stateMap.put(TMSchema.Part.WP_CLOSEBUTTON, array2);
            TMSchema.State.stateMap.put(TMSchema.Part.TKP_TRACK, new TMSchema.State[] { TMSchema.State.NORMAL });
            TMSchema.State.stateMap.put(TMSchema.Part.TKP_TRACKVERT, new TMSchema.State[] { TMSchema.State.NORMAL });
            TMSchema.State[] value3 = { TMSchema.State.NORMAL, TMSchema.State.HOT, TMSchema.State.PRESSED, TMSchema.State.FOCUSED, TMSchema.State.DISABLED };
            TMSchema.State.stateMap.put(TMSchema.Part.TKP_THUMB, value3);
            TMSchema.State.stateMap.put(TMSchema.Part.TKP_THUMBBOTTOM, value3);
            TMSchema.State.stateMap.put(TMSchema.Part.TKP_THUMBTOP, value3);
            TMSchema.State.stateMap.put(TMSchema.Part.TKP_THUMBVERT, value3);
            TMSchema.State.stateMap.put(TMSchema.Part.TKP_THUMBRIGHT, value3);
            TMSchema.State[] value4 = { TMSchema.State.NORMAL, TMSchema.State.HOT, TMSchema.State.SELECTED, TMSchema.State.DISABLED, TMSchema.State.FOCUSED };
            TMSchema.State.stateMap.put(TMSchema.Part.TABP_TABITEM, value4);
            TMSchema.State.stateMap.put(TMSchema.Part.TABP_TABITEMLEFTEDGE, value4);
            TMSchema.State.stateMap.put(TMSchema.Part.TABP_TABITEMRIGHTEDGE, value4);
            TMSchema.State.stateMap.put(TMSchema.Part.TP_BUTTON, new TMSchema.State[] { TMSchema.State.NORMAL, TMSchema.State.HOT, TMSchema.State.PRESSED, TMSchema.State.DISABLED, TMSchema.State.CHECKED, TMSchema.State.HOTCHECKED });
            TMSchema.State[] array3 = { TMSchema.State.ACTIVE, TMSchema.State.INACTIVE };
            TMSchema.State.stateMap.put(TMSchema.Part.WP_WINDOW, array3);
            TMSchema.State.stateMap.put(TMSchema.Part.WP_FRAMELEFT, array3);
            TMSchema.State.stateMap.put(TMSchema.Part.WP_FRAMERIGHT, array3);
            TMSchema.State.stateMap.put(TMSchema.Part.WP_FRAMEBOTTOM, array3);
            TMSchema.State[] value5 = { TMSchema.State.ACTIVE, TMSchema.State.INACTIVE, TMSchema.State.DISABLED };
            TMSchema.State.stateMap.put(TMSchema.Part.WP_CAPTION, value5);
            TMSchema.State.stateMap.put(TMSchema.Part.WP_MINCAPTION, value5);
            TMSchema.State.stateMap.put(TMSchema.Part.WP_MAXCAPTION, value5);
            TMSchema.State.stateMap.put(TMSchema.Part.MP_BARBACKGROUND, new TMSchema.State[] { TMSchema.State.ACTIVE, TMSchema.State.INACTIVE });
            TMSchema.State.stateMap.put(TMSchema.Part.MP_BARITEM, new TMSchema.State[] { TMSchema.State.NORMAL, TMSchema.State.HOT, TMSchema.State.PUSHED, TMSchema.State.DISABLED, TMSchema.State.DISABLEDHOT, TMSchema.State.DISABLEDPUSHED });
            TMSchema.State.stateMap.put(TMSchema.Part.MP_POPUPCHECK, new TMSchema.State[] { TMSchema.State.CHECKMARKNORMAL, TMSchema.State.CHECKMARKDISABLED, TMSchema.State.BULLETNORMAL, TMSchema.State.BULLETDISABLED });
            TMSchema.State.stateMap.put(TMSchema.Part.MP_POPUPCHECKBACKGROUND, new TMSchema.State[] { TMSchema.State.DISABLEDPUSHED, TMSchema.State.NORMAL, TMSchema.State.BITMAP });
            TMSchema.State.stateMap.put(TMSchema.Part.MP_POPUPITEM, new TMSchema.State[] { TMSchema.State.NORMAL, TMSchema.State.HOT, TMSchema.State.DISABLED, TMSchema.State.DISABLEDHOT });
            TMSchema.State.stateMap.put(TMSchema.Part.MP_POPUPSUBMENU, new TMSchema.State[] { TMSchema.State.NORMAL, TMSchema.State.DISABLED });
        }
        
        public static synchronized int getValue(TMSchema.Part key, TMSchema.State state) {
            if (TMSchema.State.stateMap == null) {
                initStates();
            }
            Enum[] array = (Enum[])TMSchema.State.stateMap.get(key);
            if (array != null) {
                int i = 0;
                while (i < array.length) {
                    if (state == array[i]) {
                        return i + 1;
                    }
                    ++i;
                }
            }
            if (state == null || state == TMSchema.State.NORMAL) {
                return 1;
            }
            return 0;
        }
    }
    
    public enum Prop
    {
        COLOR(Color.class, 204), 
        SIZE(Dimension.class, 207), 
        FLATMENUS(Boolean.class, 1001), 
        BORDERONLY(Boolean.class, 2203), 
        IMAGECOUNT(Integer.class, 2401), 
        BORDERSIZE(Integer.class, 2403), 
        PROGRESSCHUNKSIZE(Integer.class, 2411), 
        PROGRESSSPACESIZE(Integer.class, 2412), 
        TEXTSHADOWOFFSET(Point.class, 3402), 
        NORMALSIZE(Dimension.class, 3409), 
        SIZINGMARGINS(Insets.class, 3601), 
        CONTENTMARGINS(Insets.class, 3602), 
        CAPTIONMARGINS(Insets.class, 3603), 
        BORDERCOLOR(Color.class, 3801), 
        FILLCOLOR(Color.class, 3802), 
        TEXTCOLOR(Color.class, 3803), 
        TEXTSHADOWCOLOR(Color.class, 3818), 
        BGTYPE(Integer.class, 4001), 
        TEXTSHADOWTYPE(Integer.class, 4010), 
        TRANSITIONDURATIONS(Integer.class, 6000);
        
        private final Class type;
        private final int value;
        
        private Prop(Class type, int value) {
            this.type = type;
            this.value = value;
        }
        
        public int getValue() {
            return this.value;
        }
        
        @Override
        public String toString() {
            return this.name() + "[" + this.type.getName() + "] = " + this.value;
        }
    }
    
    public enum TypeEnum
    {
        BT_IMAGEFILE(TMSchema.Prop.BGTYPE, "imagefile", 0), 
        BT_BORDERFILL(TMSchema.Prop.BGTYPE, "borderfill", 1), 
        TST_NONE(TMSchema.Prop.TEXTSHADOWTYPE, "none", 0), 
        TST_SINGLE(TMSchema.Prop.TEXTSHADOWTYPE, "single", 1), 
        TST_CONTINUOUS(TMSchema.Prop.TEXTSHADOWTYPE, "continuous", 2);
        
        private final TMSchema.Prop prop;
        private final String enumName;
        private final int value;
        
        private TypeEnum(TMSchema.Prop prop, String enumName, int value) {
            this.prop = prop;
            this.enumName = enumName;
            this.value = value;
        }
        
        @Override
        public String toString() {
            return this.prop + "=" + this.enumName + "=" + this.value;
        }
        
        String getName() {
            return this.enumName;
        }
        
        static TMSchema.TypeEnum getTypeEnum(TMSchema.Prop prop, int n) {
            TMSchema.TypeEnum[] values = values();
            int length = values.length;
            int i = 0;
            while (i < length) {
                TMSchema.TypeEnum typeEnum = values[i];
                if (typeEnum.prop == prop && typeEnum.value == n) {
                    return typeEnum;
                }
                ++i;
            }
            return null;
        }
    }
}
